#!/usr/bin/perl -w

use CGI qw(:cgi);   
CGI::private_tempfiles(0);

################################################################################ 
## Define Variables
################################################################################
## Get Unique ID Passed from PHP
	my $sid = (split(/[&=]/,$ENV{QUERY_STRING}))[1];
	$sid =~ s/[^a-zA-Z0-9]//g;   

## Define Directory Paths (Must be Absolute Paths)
	my $upload_dir = $ENV{'DOCUMENT_ROOT'}."/uploads/";  
	my $tmp_dir = $ENV{'DOCUMENT_ROOT'}."/temp/";
	my $session_dir = $tmp_dir.$sid;

## Define Variable for Upload Size
	my $upload_size_file = $session_dir.'/upload_size';
	my $upload_size=0;
	my $max_upload = 10485760; 
	$CGI::POST_MAX = $max_upload;
	
## Debuging Output
	my $debug = 1;

################################################################################ 
## Auto Flush
################################################################################
umask(0);
$|++;    
################################################################################ 
## Start Processing Upload
################################################################################
print "Content-type: text/html\n\n";
if ($debug) {

	print "AJAX Perl Upload Script<br>\n";
}

################################################################################ 
## Create Upload Directory if it does not exist
################################################################################
print "Checking for Uploads Directory -> ";
if(-d $upload_dir){ 
	print "<b style='color:green;'>Found</b><br>"; 
	chmod 0777, $upload_dir;
} else {
	print "Creating Upload Directory : ";
	if (mkdir($upload_dir, 0766)) { print "<b style='color:green;'>Success</b><br>"; } else { print "<b style='color:red;'>Failure</b><br>";}
}

################################################################################ 
## Create Temporary Directory
################################################################################
print "Check for Temp Directory -> ";
if(-d $tmp_dir){ print "<b style='color:green;'>Found</b><br>"; chmod 0777, $tmp_dir;
} else {
	print "Creating Temp Directory: "; 
	if (mkdir($tmp_dir, 0777)) { print "<b style='color:green;'>Success</b><br>"; } else { print "<font color='red'>Failure</font><br>";}
}
################################################################################ 
## Create Session Temporary Directory
################################################################################
print "Check for Session Temp Directory -> ";
if(-d $session_dir){ print "<b style='color:green;'>Found</b><br>"; chmod 0777, $session_dir;
} else {
	print "Creating Directory: "; 
	if (mkdir($session_dir, 0777)) { print "<b style='color:green;'>Success</b><br>"; } else { print "<font color='red'>Failure</font><br>";}
}
################################################################################ 
## Check Upload Size
################################################################################
if ($ENV{'CONTENT_LENGTH'}> $max_uplaod) {
	print "<scrript type='text/javascript'>parent.cancelUpload('Max Upload Size Exceeded');</script>";
} else {

################################################################################ 
## Create upload_size File
################################################################################
	print "Creating Upload Size file -> ";
	open FLENGTH, ">$upload_size_file";
		$upload_size = $ENV{'CONTENT_LENGTH'};
		print FLENGTH $upload_size;
	close FLENGTH;
	chmod 0777, $upload_size_file;
	if(-e  $upload_size_file){ print "<b style='color:green;'>Success</b><br>"; } else { print "<b style='color:red;'>Failure</b><br>";}
	
################################################################################ 
## Relocate Temporary File Directory
################################################################################
	print "Setting Private Temp Directory -> ";
	if ($TempFile::TMPDIRECTORY) { 
		$TempFile::TMPDIRECTORY = $session_dir;
		print "<b style='color:green;'>Success</b><br>";
	}
	elsif (
		$CGITempFile::TMPDIRECTORY){  $CGITempFile::TMPDIRECTORY = $session_dir; 
		print "<b style='color:green;'>Success</b><br>";
	} else {
		print "<b style='color:red;'>Failure</b><br>";
	}
	sleep(2);
################################################################################ 
## Process Uploaded File
################################################################################
	if(-d $session_dir){ 
		my $query = new CGI;
		my $file_name = $query->param("filename");
		$file_name =~ s/.*[\/\\](.*)/$1/;
		my $upload_file_path = $upload_dir.$file_name;
		my $upload_filehandle = $query->upload("filename");
		my $tmp_filename = $query->tmpFileName($upload_filehandle);
		close($upload_filehandle);
		print "Moving File to Upload Directory -> ";
		if ( rename($tmp_filename, $upload_file_path) ) { 
			print "<b style='color:green;'>Success</b><br>"; 
		} else { 
			print "<font color='red'>Failure</font><br>";
		}
		print "Removing upload_size file -> ";
		if (unlink($upload_size_file)) { print "<b style='color:green;'>Success</b><br>"; } else { print "<font color='red'>Failure</font><br>";}
	}
}
################################################################################ 
## Remove Session Temporary File
################################################################################
print "Removing Session Temporary Directory -> ";
if (rmdir($session_dir)) { print "<b style='color:green;'>Success</b><br>"; } else { print "<font color='red'>Failure</font><br>";}